#include <glib.h>
#include <pi-socket.h>
#include <pi-sockaddr.h>
#include <pi-sync.h>
#include <gpilot-conduit.h>

/* This conduit will not compile!!!, none of the SyncAbs functions are
   actually defined.  For implementations of these functions see the
   pilot-link package code under dubious.  Hopefully, we will have better
   docs soon :) */

typedef struct MySyncAbs {
  SyncAbs abs;
  gint32 dummy_data_i_need;
} MySyncAbs;

static pi_uint32 MyCreatorId(MySyncAbs *abs) 
{
  return (pi_uint32)get_creator_id();
}

static pi_uint32 MyDataBaseName(MySyncAbs *abs) 
{
  return (pi_uint32)get_db_name();
}

MySyncAbs abs = {
  {
    MyMatchRecord,
    MyFreeMatch,
    MyArchiveLocal,
    MyArchiveRemote,
    MyStoreRemote,
    MyClearStatusArchiveLocal,
    MyIterate,
    MyIterateSpecific,
    MyPurge,
    MySetStatus,
    MySetArchived,
    MyGetPilotID,
    MySetPilotID,
    MyCompare,
    MyCompareBackup,
    MyFreeTransmit,
    MyDeleteAll,
    MyTransmit,
    MyDatabaseName,
    MyCreatorId
  }, 0xfeedbeef
}

static gint run_configuration(GPilotConduit *c, gchar *args[], gchar *env[])
{
  /* Fork and execve a configuration program */
}

static gint32 get_db_name(GPilotConduit *c);
static gint32 get_creator_id(GPilotConduit *c);
static gint synchronize(GPilotConduit *c, GPilotDBInfo *dbi);
static gint copy_from_remote(GPilotConduit *c, GPilotDBInfo *dbi);
static gint copy_to_remote(GPilotConduit *c, GPilotDBInfo *dbi);

static GPilotConduit conduit = {
  GPILOT_CONDUIT_STANDARD,
  {get_creator_id,
   get_db_name,
   copy_to_remote,
   copy_from_remote,
   my_synchronize},
  {run_configuration},
  NULL,
  NULL
}

static gint copy_to_remote(GPilotConduit *c, GPilotDBInfo *dbi)
{
  return CopyToRemote(dbi->pilot_socket, dbi->pisock_dbinfo.index, &abs);
}

static gint copy_from_remote(GPilotConduit *c, GPilotDBInfo *dbi)
{
  return CopyToRemote(dbi->pilot_socket, dbi->pisock_dbinfo.index, &abs);
}

static gint synchronize(GPilotConduit *c, GPilotDBInfo *dbi)
{
  /* Other logic to determine fast or slow sync could be conduit dependent */
  if(gpilot_sync_pc_match(dbi)) {
    return SlowSync(dbi->pilot_socket, dbi->pisock_dbinfo.index, &abs);
  } else {
    return FastSync(dbi->pilot_socket, dbi->pisock_dbinfo.index, &abs);
  }
}

static gint32 get_creator_id(GPilotConduit *c)
{
  return 0xfeedface;
}

static gchar* get_db_name(GPilotConduit *c)
{
  return "SampleDB";
}

GPilotConduit *conduit_get_pilot_conduit()
{
  return &conduit;
}

void conduit_destroy_gpilot_conduit(GPilotConduit *c)
{
  return; /* Nothing to free since we don't dynamically allocate */
}

