#ifndef _MULTI_FILE_H_
#define _MULTI_FILE_H_

#include <glib.h>
#include <gtk/gtkcontainer.h>

#ifdef __cplusplus
extern "C" 
{
#endif /* __cplusplus */

#define MULTI_FILE(obj)          GTK_CHECK_CAST (obj, multi_file_get_type (), MultiFile)

#define MULTI_FILE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, multi_file_get_type (), MultiFileClass)
#define IS_MULTI_FILE(obj)       GTK_CHECK_TYPE (obj, multi_file_get_type ())
  
  
  typedef struct _MultiFile       MultiFile;
  typedef struct _MultiFileClass  MultiFileClass;
  
  struct _MultiFile {
    GtkTable table;
    
    GtkWidget *current_file_list;
    GtkWidget *selected_file_list;
    gchar *cwd;
    GList *sel_files;
    gchar *cur_file;
    gint rcur_pos;
  };
  
  struct _MultiFileClass
  {
    GtkTableClass parent_class;
    
    void (*file_selected) (MultiFile *w);
    void (*file_unselected) (MultiFile *w);
  };
  
  guint          multi_file_get_type        (void);
  GtkWidget*     multi_file_new             (void);
  void           multi_file_set_cwd         (MultiFile *,const gchar *);
  GList *        multi_file_get_selected_files(MultiFile *);
  void           multi_file_set_selected_files(MultiFile *,gchar *names[]);
  void           multi_file_update_file_list(MultiFile *w);

  typedef void (*MultiFileSelectionSignalFunc)(GtkObject *, gchar *,gpointer);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _MULTI_FILE_H_ */



